import functools
import logging
import os
import time


def __loger(file_path):
    logger = logging.getLogger()
    logger.level=logging.INFO
    handler=logging.FileHandler(file_path,mode="a",encoding="utf-8")
    formatter = logging.Formatter('时间：%(asctime)s， - %(name)s - ，日志级别：%(levelname)s -，日志信息 %(message)s')
    handler.setFormatter(formatter)
    logger.addHandler(handler)
    return logger

log_dir=os.path.join(os.path.dirname(__file__),'report','logs')
log_name="BPMAPITest" + time.strftime("%Y_%m_%d_%H_%M_%S", time.localtime()) + ".log"
log_path=os.path.join(log_dir,log_name)
__loger=__loger(log_path)

def log_decorator(func):
    @functools.wraps(func)
    def wrapper(*args, **kwargs):
        __loger.info(f"执行的功能为：{func.__name__}，功能的描述为：{func.__doc__},所在文件为：{func.__code__.co_filename},所在的行为：{func.__code__.co_firstlineno}")
        try:
            res= func(*args, **kwargs)
        except Exception as e:
            __loger.error(f"执行的功能为：{func.__name__}, 功能的描述为：{func.__doc__}, 所在的文件为：{func.__code__.co_filename}, 所在的行为：{func.__code__.co_firstlineno}.报错，错误为：{type(e)}, 错误的描述为：{e}")
            raise e
        else:
            return res
    return wrapper
